/*
 * Copyright 2008 The Yacafe Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE YACAFE PROJECT ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
 * EVENT SHALL THE YACAFE PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the Yacafe Project.
 */

#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include "debug.h"

void
hexdump(FILE *fp, char *data,int len)
{
int  a, b;
char *ldat;

	ldat = (char *)calloc(len + 1, sizeof(char));

	for(a = 0; a < len; a++)
	{
		if(!isprint((u_char)(data[a])))
		{
			ldat[a] = '.';
		}
		else
		{
			ldat[a] = data[a];
		}
	}

	fprintf(fp, "+----------------------------------------------------------------------------\n");
	fprintf(fp, "| hexdump(): %dbyte\n", len);
	fprintf(fp, "+------+-------------------------------------------------+------------------+\n");

	for(a = 0; a < len; a = a + 16)
	{
		fprintf(fp, "| %04x | ", a);

		for(b = 0; b < 16; b++)
		{
			if(a + b < len)
			{
				fprintf(fp, "%02x ", 0xFF & data[a + b]);
			}
			else
			{
				fprintf(fp, "   ");
			}
		}

		fprintf(fp, "| ");

		for(b = 0; b < 16; b++)
		{
			if(a + b < len)
			{
				if(isascii((u_char)(ldat[a + b])) && isprint((u_char)(ldat[a + b])))
				{
					fprintf(fp, "%c", ldat[a + b]);
				}
				else
				{
					fprintf(fp, ".");
				}
			}
			else
			{
				fprintf(fp, " ");
			}
		}

		fprintf(fp, " |\n");
	}

	fprintf(fp, "+------+-------------------------------------------------+------------------+\n");
	fprintf(fp, "\n");

	free(ldat);
}
