/*
 * Copyright 2008 The Yacafe Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE YACAFE PROJECT ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
 * EVENT SHALL THE YACAFE PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the Yacafe Project.
 */

#ifndef __STRUITL_H__
#define __STRUITL_H__

#include "strarray.h"

extern char *
strutil_tolower(char *str);
extern char *
strutil_toupper(char *str);
extern char *
strutil_dup(const char *src);
extern char *
strutil_ndup(const char *src, int size);
extern char *
strutil_chomp(char *str);
extern char *
strutil_trim(const char *src);
extern char *
strutil_trim_direct(char *str);
extern char *
strutil_exchange(char **dst, const char *src);
extern char *
strutil_unit(const char *str1, const char *str2, const char *glue);
extern strarray_t *
strutil_split(const char *src, const char *delim, int num);
extern int
strutil_isempty(const char *src);
extern int
strutil_isequal(const char *str1, const char *str2);
extern int
strutil_iscaseequal(const char *str1, const char *str2);
extern int
strutil_isdigit(const char *src);
extern int
strutil_isspace(const char *src);
extern int
strutil_isrange(const char *src, int min, int max);
extern int
strutil_tailis(const char *src, const char *str);
extern char *
strutil_take_crlf(char *str);
extern int
strutil_headwith(const char *src, const char *str);
extern int
strutil_tailwith(const char *src, const char *str);
extern int
strutil_caseheadwith(const char *src, const char *str);
extern int
strutil_casetailwith(const char *src, const char *str);
extern char *
strutil_dequote(char *src, const char *squote, const char *equote);

#endif
